package ballwar.model;

import lrs.*;
import java.util.*;

public class BallCmdSet implements IBallCmd {
  private LRStruct _cmdSet = new LRStruct();
  
  private IAlgo _runCmdsAlgo = new IAlgo() {
    public Object emptyCase(LRStruct host, Object... context) {
      return null;
    }
    
    public Object nonEmptyCase(LRStruct host, Object... context) {
      ((IBallCmd) host.getFirst()).apply((Ball) context[0]);
      return host.getRest().execute(this, context);
    }
  };
  
  private IAlgo _remCmdAlgo = new IAlgo() {
    public Object emptyCase(LRStruct host, Object... cmd) {
      return null;
    }
    
    public Object nonEmptyCase(LRStruct host, Object... cmd) {
      if(host.getFirst().equals(cmd[0])) {
        return host.removeFront();
      }
      else {
        return host.getRest().execute(this, cmd);
      }
    }
  };
  
  public void addCmd(IBallCmd cmd) {
    _cmdSet.insertFront(cmd);
  }
  
  public IBallCmd removeCmd(IBallCmd cmd) {
    return (IBallCmd) _cmdSet.execute(_remCmdAlgo, cmd);
  }
  
  public void clear() {
    _cmdSet = new LRStruct();
  }
  
  public void apply(Ball context) {
    _cmdSet.execute(_runCmdsAlgo, context);
  }
}