package ballwar.model;

public class FilterCmd implements IBallCmd {

 private Ball _host;
 private IFilterCriteria _criteria;
 private IBallCmd _passCmd;
 private IBallCmd _rejectCmd;
 
 public static interface IFilterCriteria {
   public abstract IBallCmd selectCmd(Ball host, Ball otherBall, IBallCmd passCmd, IBallCmd rejectCmd);
 }
 
 public FilterCmd(Ball host, IFilterCriteria criteria, IBallCmd passCmd, IBallCmd rejectCmd) {
   _host = host;
   _criteria = criteria;
   _passCmd = passCmd;
   _rejectCmd = rejectCmd;
 }
  
 public void apply(Ball otherBall) {
   _criteria.selectCmd(_host, otherBall, _passCmd, _rejectCmd).apply(otherBall);
 }
}