package ballwar.model;
import java.awt.*;
import util.*;


/**
 * Interface that represents a "moveable" object.
 */
public abstract interface IMoveable {
  /**
  * The current location of the moveable object.
  * @return The current location Point2DDouble.
  */
 public abstract Point2DDouble getLocation();
  /**
  * Tells the moveable object to move to the left by an amount or at a rate determined by the object.
  */
 public abstract void moveLeft();
  /**
  * Tells the moveable object to move to the right by an amount or at a rate determined by the object.
  */
 public abstract void moveRight();
  /**
  * Tells the moveable object to move to the up by an amount or at a rate determined by the object.
  */
 public abstract void moveUp();
  /**
  * Tells the moveable object to move to the down by an amount or at a rate determined by the object.
  */
 public abstract void moveDown();
  /**
  * Tells a moveable object to stop moving.
  */
 public abstract void stop();
}