package ballwar.model.filterCriteria;
import ballwar.model.*;
import util.*;

public class ArcViewCriteria implements FilterCmd.IFilterCriteria {
  private double _cosTheta;
  
  public ArcViewCriteria(double theta) {
    _cosTheta = Math.cos(theta);
  }
  
  public IBallCmd selectCmd(Ball host, Ball otherBall, IBallCmd passCmd, IBallCmd rejectCmd){
    Point2DDouble hostVel = host.getVelocity();
    Point2DDouble unitVecToOther = host.getLocation().unitVecTo(otherBall.getLocation());
    
    double dotProd = hostVel.x*unitVecToOther.x+hostVel.y*unitVecToOther.y;
    
    return 
      _cosTheta <= (dotProd/(hostVel.getLength())) ?
      passCmd :
      rejectCmd;
  }
}
