package ballwar.model.paint;
import java.awt.*;
import java.awt.geom.*;
import util.*;

/**
 * Concrete PolygonFactory that creates fish-shaped Polygons that 
 * have a longer tail and an open mouth.
 */
public class Fish1PolygonFactory extends PolygonFactory {
  
  /**
   * Constructor that calls the PolygonFactory superclass constructor
   * with the scale factor and polygon points that define the fish
   * shape.
   */
  public Fish1PolygonFactory() {
    super(new AffineTransform(), 1.0/16.0,
          new Point2DDouble(-15, 10),
          new Point2DDouble(-9, 3),
          new Point2DDouble(-8, 4),
          new Point2DDouble(-4, 5),
          new Point2DDouble(2, 7),
          new Point2DDouble(4, 7),
          new Point2DDouble(9, 6),
          new Point2DDouble(12, 5),
          new Point2DDouble(14, 4),
          new Point2DDouble(15, 3),
          new Point2DDouble(16, 2),
          new Point2DDouble(13, 0),
          new Point2DDouble(16, -2),
          new Point2DDouble(15, -3),
          new Point2DDouble(14, -4),
          new Point2DDouble(12, -5),
          new Point2DDouble(9, -6),
          new Point2DDouble(4, -7),
          new Point2DDouble(2, -7),
          new Point2DDouble(-4, -5),
          new Point2DDouble(-8, -4),
          new Point2DDouble(-9, -3),
          new Point2DDouble(-15, -10));
  }
}
