package ballwar.model.paint;

import ballwar.model.*;
import java.awt.*;
import java.awt.geom.*;

/**
 * Paint strategy that paints a fish-shaped Polygon generated
 * by a Fish2PolyfonFactory.
 */
public class Fish2PaintStrategy extends ShapePaintStrategy {

  /**
   * No-parameter constructor that instantiates the AffineTransform for
   * internal use.
   */
  public Fish2PaintStrategy(){
    this(new AffineTransform());
  }
  
  /**
   * Constructor that takes an external AffineTransform
   * @param at The AffineTransform to use for internal use.
   */
  public Fish2PaintStrategy(AffineTransform at){
    super(at, new Fish2PolygonFactory().makeShape(0,0, 1, 1));
  }

}