package ballwar.model.paint;

import ballwar.model.*;
import java.awt.*;
import java.awt.geom.*;

/**
 * Subclass of AnimatePaintStrategy that alternates between
 * a Fish1PaintStrategy and a Fish2PaintStrategy.
 */
public class SwimFishPaintStrategy extends AnimatePaintStrategy {
  
  /**
   * No-parameter constructor that instantiates an AffineTransform 
   * for internal use.
   */
  public SwimFishPaintStrategy(){
    this(new AffineTransform());
  }
  
  /** 
   * Constructor that takes an external AffineTransform for
   * internal use.
   */
  public SwimFishPaintStrategy(AffineTransform at){
    super(at, new Fish1PaintStrategy(at),new Fish2PaintStrategy(at));
  }

}