package ballwar.model.strategy;

import ballwar.model.*;


/**
 * Abstract strategy that provides default behaviors that do nothing.
 * Differs from the IUpdateStrategy.NullObject in that the 
 * purpose of this class is for subclassing, not to represent
 * the null entity.
 */
public abstract class ANoOpStrategy implements IUpdateStrategy {
  
  /**
   * No-op
   */
  public void updateState(Ball context) {
  }
  
  /**
   * No-op
   */
  public void updateCollision(Ball context, Ball target) {
  }
  
  /**
   * No-op
   */
  public void init(Ball context) {    
  }
  
  /**
   * No-op
   */
  public void kill(Ball context) {
  }
}
