package ballwar.model.strategy;
import ballwar.model.*;
import java.awt.*;
import util.*;

public class AlignStrategy extends ANoOpStrategy {
  private Ball host;
  private double factor = 0.5;
  private double distance = 50;
  
  private Point2DDouble _totalAcc;
  
  private IBallCmd alignCmd = new IBallCmd() {
    public void apply(Ball otherBall) {
      if(otherBall!=host) {
       Point2DDouble acc = host.getVelocity().vecTo(otherBall.getVelocity());
       double d = host.getLocation().distance(otherBall.getLocation());
       acc.multBy(factor*Math.exp(-d/distance));
        _totalAcc.translate(acc);
      }
    }
  };
  
  public void updateState(Ball context) {
    _totalAcc = new Point2DDouble();
    context.getEnv().getDispatcher().notifyAll(alignCmd);
    _totalAcc.multBy(context.getEnv().getDeltaTime()*factor);
    context.addUpdateCmd(new IBallCmd() {
      public void apply(Ball host) {       
        host.getVelocity().translate(_totalAcc);
      }
    });
  }
  
  public void init(Ball context) {
    host = context;
  }
  
}