package ballwar.model.strategy;
import ballwar.model.*;
import java.awt.*;
import util.*;

public class AversionStrategy extends ANoOpStrategy {
  private Ball host;
  private double factor = 10.0;
  
  private IBallCmd aversionCmd = new IBallCmd() {
    public void apply(Ball otherBall) {
       if(otherBall!=host) {
        final Point2DDouble acc = host.getLocation().unitVecTo(otherBall.getLocation());
        acc.multBy(host.getEnv().getDeltaTime()*otherBall.getMass()*factor);
        double distance = otherBall.getLocation().distance(host.getLocation());

        if(distance < otherBall.getRadius()) {
          double r = otherBall.getRadius();
          acc.multBy(distance/(r*r*r));
        }
        else{
          acc.multBy(1.0/(distance*distance));
        }  
        host.addUpdateCmd(new IBallCmd() {
          public void apply(Ball host) {
            host.getVelocity().translate(acc);
          }
        });
      }
    }
  };
  public void updateState(Ball context) {
    context.getEnv().getDispatcher().notifyAll(aversionCmd);
    
  }
  
  public void init(Ball context) {
    host = context;
  }
  
}