package ballwar.model.strategy;
import java.awt.*;

import ballwar.model.*;

/**
 * A strategy that demonstrates self-modifying behavior by replacing itself with another strategy after a certain length of time.
 * Based on AUpdateStrategy, so it randomly initializes the ball.
 */
public class Change1Strategy extends AUpdateStrategy {

  /**
	 * The counter that deternines the number of updates before this strategy replaces itself in its context.
	 */
	private int i = 500;
  
  /**
	 * If the counter is zero, sets the context's strategy to a new Change2Strategy.
	 * Otherwise, decrements the counter. 
	 * @param context The strategy's context.
	 */
	public void updateState(Ball context) {
    if(i==0) context.setStrategy(new Change2Strategy());
    else i--;
  }
}
