package ballwar.model.strategy;
import java.awt.*;

import util.*;
import ballwar.model.*;

/**
 * Similar self-modifying behavior to Change1Strategy.   After a period of time, replaces itself with a new Change1Strategy.
 * Randomly changes its color when updateState is called.
 * Based on AUpdateStrategy, so it randomly initializes the ball.
 */
public class Change2Strategy extends AUpdateStrategy {
  /**
	 * Randomizer to generate random colors
	 */
	private IRandomizer rand = Randomizer.Singleton;
  /**
	 * Counter that determines the number of updates before this strategy replaces itself.
	 */
	private int i = 500;
  
  /**
	 * Sets the context's color to a random color.
	 * If the count is zero, sets the context's strategy to a  new Change1Strategy.
	 * otherwise, decrements the counter.
	 * @param context The strategy's context.
	 */
	public void updateState(Ball context) {
    context.setColor(rand.randomColor());
    if(i==0) context.setStrategy(new Change1Strategy());
    else i--;
  }
}
