package ballwar.model.strategy;
import ballwar.model.*;
import util.*;

/**
 * ANoOpStrategy-based strategy that randomly sets the context's color each time its updateState() method is called.
 */
public class ColorStrategy extends ANoOpStrategy {
  /**
  * Randominzer used to generate the random colors needed.
  */
 private IRandomizer rand = Randomizer.Singleton;

  /**
  * Updates the state of the context by randomly setting its color.
  */
 public void updateState(Ball context) {
   context.addUpdateCmd(new IBallCmd() { 
     public void apply(Ball host) {
       host.setColor(rand.randomColor());
     }
   });
  }
}
