package ballwar.model.strategy;
import ballwar.model.*;
import java.awt.*;
import util.*;

public class FrictionStrategy extends ANoOpStrategy {
  private Ball host;
  private double lossRate = 0.01;
  
  public void updateState(Ball context) {
    final double factor = 1.0-(context.getEnv().getDeltaTime()*lossRate);
    context.addUpdateCmd(new IBallCmd() {
      public void apply(Ball host) {       
        host.getVelocity().multBy(factor);
      }
    });
    
  }
  
}