package ballwar.model.strategy;
import java.awt.*;

import ballwar.model.*;


/**
 * An ANoOpStrategy-based strategy who initializes its context to have an infinitely large (positive) mass.   
 * Thus the velocity of the context is not altered by a collision.   Can be combined with RockStrategy to 
 * create an immovable object.    Warning:  infinitely heavy balls continuously add energy into the system, 
 * causing the velocitiy of all other balls to increase without an upper bound.
 */
public class HeavyStrategy extends ANoOpStrategy {

  /**
	 * Initializes the context's mass to positive infinity.
	 * @param context The strategy's context.
	 */
	public void init(Ball context) {
    context.setMass(Double.POSITIVE_INFINITY);
  }
}
