package ballwar.model.strategy;
import ballwar.model.*;

/**
 * An ANoOpStrategy-based strategy that kills any ball that it collides with.
 */
public class KillStrategy extends ANoOpStrategy {

  /**
	 * Kills the target ball (calls its kill() method).
	 * @param context The strategy's context.
	 * @param target The ball to kill.
	 */
	public void updateCollision(Ball context, Ball target) {
    target.kill();
  }  
}