package ballwar.model.strategy;
import ballwar.model.*;
import java.awt.*;
import util.*;

public class LeaderStrategy extends ANoOpStrategy {
  private Ball host;
  
  
  private IBallCmd leadCmd = new IBallCmd() {
    public void apply(Ball otherBall) {
      if(otherBall!=host) {
        if(host.getLocation().vecTo(otherBall.getLocation()).getLength()<= (host.getRadius()+otherBall.getRadius())){
          otherBall.setMoveStrategy(new IBallMoveStrategy(){
            public void move(Ball otherHost) {
              host.getMoveStrategy().move(otherHost);
            }
            
            public Point2DDouble getVelocity() {
              return host.getVelocity();
            }
            public void setVelocity(Point2DDouble v)
            {
              // no-op
            }
          });
        }
      }
    }
  };
  public void updateState(Ball context) {
    context.getEnv().getDispatcher().notifyAll(leadCmd);    
  }
  
  public void init(Ball context) {
    host = context;
  }
  
}