package ballwar.model.strategy;
import ballwar.model.*;
import java.awt.*;
import util.*;

public class SeparationStrategy extends ANoOpStrategy {
  private Ball host;
  private double springConstant = 100000.0;
  private double separationDistance= 20;
  private double fallOff = 10.0;
  
  private IBallCmd separationCmd = new IBallCmd() {
    public void apply(Ball otherBall) {
      if(otherBall!=host) {
        
        final Point2DDouble acc = host.getLocation().unitVecTo(otherBall.getLocation());
        acc.multBy(host.getEnv().getDeltaTime()*springConstant/host.getMass());
        double distance = otherBall.getLocation().distance(host.getLocation());
        double d = host.getRadius()+otherBall.getRadius()+separationDistance;
        acc.multBy(Math.log(distance/d)*Math.exp(-fallOff*(distance-d)/d));
        
//        if(d>distance) {
//          acc.multBy(Math.log(distance/d));
        
        host.addUpdateCmd(new IBallCmd() {
          public void apply(Ball host) {
            host.getVelocity().translate(acc);
          }
        });
//        }
      }
    }
  };
  public void updateState(Ball context) {
    context.getEnv().getDispatcher().notifyAll(separationCmd);
    
  }
  
  public void init(Ball context) {
    host = context;
  }
  
}