package ballwar.model.strategy;

import ballwar.model.*;

import ballwar.model.filterCriteria.*;

import java.awt.*;

import util.*;



public class TargetedStrategy extends ANoOpStrategy {

  private Ball host;
  private double factor = 0.1;
  private double distance = 50;
  private Point2DDouble _totalAcc;

  private IBallCmd alignCmd = new IBallCmd() {
    public void apply(Ball otherBall) {
      if(otherBall!=host) {
       Point2DDouble acc = host.getVelocity().vecTo(otherBall.getVelocity());
       double d = host.getLocation().distance(otherBall.getLocation());
       acc.multBy(factor*Math.exp(-d/distance));
        _totalAcc.translate(acc);
      }
    }
  };

  public void updateState(Ball context) {

    _totalAcc = new Point2DDouble();
    context.getEnv().getDispatcher().notifyAll(new FilterCmd(context, new ArcViewCriteria(Math.PI/4),alignCmd, IBallCmd.NoOp));
    _totalAcc.multBy(context.getEnv().getDeltaTime()*factor);
    context.addUpdateCmd(new IBallCmd() {
      public void apply(Ball host) {       
        host.getVelocity().translate(_totalAcc);
      }
    });
  }

  public void init(Ball context) {
    host = context;
  }  

}