package ballwar.model.strategy;
import util.*;

import ballwar.model.*;

/**
 * An ANoOpStrategy-based strategy that randomly modifies the velocity whenever the state of the context is updated.
 */
public class WanderStrategy extends ANoOpStrategy {
  /**
	 * The Randomizer used to generate the random velocity increment vector's coordinates.
	 */
	private IRandomizer _rand = Randomizer.Singleton;
  /**
	 * The maximum absolute value of any of the velocity increment's coordinates.
	 */
	private int _delta = 2;
  
  /**
	 * Adds a random vector value to  the context's velocity.  The coordinates of the random 
	 * vector each have an absolute value less than or equal to a stored maximum. 
	 * @param context The context for this strategy. 
	 */
	public void updateState(Ball context) {
    context.getVelocity().translate(_rand.randomInt(-_delta,_delta),_rand.randomInt(-_delta,_delta));
  }
}
