package ballwar.view;

/**
 * Interface to the model that the view uses to control the game itself.
 */
public interface IGameCtrlAdapter {
  /**
	 * Asks the model to create a player with the given name.   An object representing a player will be returned.
	 * The view has no knowledge of the type or usage of the returned player object, only that
	 * it will save it and return the currently selected one when requested.    In the current implementation,
	 * players are held in a drop list, where the toString() return value of the player is displayed on the 
	 * drop list.
	 * @param name The name of the new player.
	 * @return The new player.
	 */
	public abstract Object makePlayer(String name);
  /**
	 * Askas that the model start the game.
	 */
	public abstract void start();
  /**
	 * Asks that the model end the game.
	 */
	public abstract void end();
  /**
	 * Asks that the model pause the game.
	 */
	public abstract void pause();
}
